﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp6
{
    public class Program
    {
        public enum JakToDopadlo { OK, DeleniNulou, SpatnyPocetCisel, 
            SpatnyZapisCisla, SpatnyRozsah }
        public static Tuple<int, JakToDopadlo> Podil(string s)
        {
            char[] odd = { ' ' };
            string[] ss = s.Split(odd, StringSplitOptions.RemoveEmptyEntries);
            if (ss.Length!=2)
            {
                return new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel);
            }

            try
            {
                int a = int.Parse(ss[0]);
                int b = int.Parse(ss[1]);
                return new Tuple<int, JakToDopadlo>(a / b, JakToDopadlo.OK);
            }
            /*
            catch (DivideByZeroException)
            {
                return new Tuple<int, JakToDopadlo>
                    (42, JakToDopadlo.DeleniNulou);
            }*/
            catch (FormatException)
            {
                return new Tuple<int, JakToDopadlo>
                    (42, JakToDopadlo.SpatnyZapisCisla);
            }
            catch (OverflowException)
            {
                return new Tuple<int, JakToDopadlo>
                    (42, JakToDopadlo.SpatnyRozsah);
            }





            return new Tuple<int,
                JakToDopadlo>(7, JakToDopadlo.OK);
        }

        static int PocetTestu = 0;
        static int PocetChyb = 0;
        public static void OtestujPodil(
            string vstup,
            Tuple<int, JakToDopadlo> spravnyVysledek)
        {
            PocetTestu++;
            Tuple<int, JakToDopadlo> vysledek = Podil(vstup);
            if (vysledek.Item2 != spravnyVysledek.Item2)
            {
                PocetChyb++;
                Console.WriteLine(
                    $"CHYBA: ({vstup}) ->"
                    +$"{vysledek.Item2} misto {spravnyVysledek.Item2}");
                return;
            }
            if ((vysledek.Item2==JakToDopadlo.OK)
                &&(vysledek.Item1 != spravnyVysledek.Item1))
            {
                PocetChyb++;
                Console.WriteLine(
                    $"CHYBA: ({vstup}) ->"
                    + $"{vysledek.Item1} misto {spravnyVysledek.Item1}");
                return;
            }
        }

        static void Main_vyjimky(string[] args)
        {
            throw new IndexOutOfRangeException("abcd");


            int i = 0;
            Console.WriteLine("PRED");
            try
            {
                i = i / i;
                Console.WriteLine("ZA chybou");

            }
            catch (OverflowException)
            { }
            catch(DivideByZeroException e)
            {
                Console.WriteLine("DELIM NULOU");
                Console.WriteLine(e.Message);

                checked
                {
                    int a = 0;
                    a = a / a;
                }
                //throw;
            }
            finally
            {
                Console.WriteLine("Tohle se provede vzdycky");
            }
            Console.WriteLine("KONEC");
            




            try
            {
                Console.WriteLine("pred");
                i = i / i;
                Console.WriteLine("za");

            }
            catch (Exception)
            {
                i = 99;
            }
            Console.WriteLine(i);
        }

            static void Main(string[] args)
        {
            OtestujPodil("24 6", new Tuple<int, JakToDopadlo>(4, JakToDopadlo.OK));
            OtestujPodil("24 4", new Tuple<int, JakToDopadlo>(6, JakToDopadlo.OK));
            OtestujPodil("24 2", new Tuple<int, JakToDopadlo>(12, JakToDopadlo.OK));
            OtestujPodil("1 7", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.OK));
            OtestujPodil("0 7", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.OK));

            OtestujPodil("7 0", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.DeleniNulou));

            OtestujPodil("7", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel));
            OtestujPodil("7 8 9", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel));
            OtestujPodil("", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel));

            OtestujPodil("Ahoj mami", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyZapisCisla));
            OtestujPodil("Ahoj mami, jak se mas", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel));
            OtestujPodil("Dva", new Tuple<int, JakToDopadlo>(0, JakToDopadlo.SpatnyPocetCisel));

            OtestujPodil("14 -7", new Tuple<int, JakToDopadlo>(-2, JakToDopadlo.OK));
            OtestujPodil("-14 7", new Tuple<int, JakToDopadlo>(-2, JakToDopadlo.OK));
            OtestujPodil("-14 -7", new Tuple<int, JakToDopadlo>(2, JakToDopadlo.OK));

            OtestujPodil("- -", new Tuple<int, JakToDopadlo>(2, JakToDopadlo.SpatnyZapisCisla));

            OtestujPodil("14 -0", new Tuple<int, JakToDopadlo>(-2, JakToDopadlo.DeleniNulou));
            OtestujPodil("-14 -0", new Tuple<int, JakToDopadlo>(-2, JakToDopadlo.DeleniNulou));
            OtestujPodil("0 0", new Tuple<int, JakToDopadlo>(-2, JakToDopadlo.DeleniNulou));

            OtestujPodil("7 1", new Tuple<int, JakToDopadlo>(7, JakToDopadlo.OK));

            OtestujPodil("mami 0", new Tuple<int, JakToDopadlo>(7, JakToDopadlo.SpatnyZapisCisla));

            OtestujPodil("22222222222222222222222222222222222222222 2", 
                new Tuple<int, JakToDopadlo>(7, JakToDopadlo.SpatnyRozsah));

            Console.WriteLine($"Testu/Chyb: {PocetTestu}/{PocetChyb}");
        }
    }
}
