﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp5
{
    class Program
    {

        static int Porovnej<T, W>(T a, T b)
            where T: IComparable

        {
            if (a < b)
                return -1;
            return a.CompareTo(b);
        }


        static void Vymen<T>(ref T a, ref T b)
        {
            T pom = a; a = b; b = pom;
        }
        static void Main(string[] args)
        {
            List<int> seznam = new List<int>();
            seznam.Add(7);
            seznam.Add(22);
            Console.WriteLine( seznam.Count );
            foreach (int x in seznam)
            {
                Console.Write($" {x}");
            }
            Console.WriteLine();



            int a = 7;
            int b = 22;
            Console.WriteLine($"a={a} b={b}");
            Vymen<int>(ref a, ref b);
            Console.WriteLine($"a={a} b={b}");

            double da = 7.0;
            double db = 22.0;
            Console.WriteLine($"da={da} db={db}");
            Vymen<double>(ref da, ref db);
            Console.WriteLine($"da={da} db={db}");

            string sa = "sedm";
            string sb = "dvacet dva";
            Console.WriteLine($"sa={sa} sb={sb}");
            Vymen<string>(ref sa, ref sb);
            Console.WriteLine($"sa={sa} sb={sb}");
        }
    }
}
