﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using ConsoleApp6;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp6.Tests
{
    [TestClass()]
    public class ProgramTests
    {
        [TestMethod()]
        public void OtestujPodilTest1()
        {
            Tuple<int, Program.JakToDopadlo> vysledek
                = Program.Podil("24 6");
            Assert.AreEqual(vysledek.Item1, 4);
            Assert.AreEqual(vysledek.Item2,
                Program.JakToDopadlo.OK);
        }

        [TestMethod()]
        public void OtestujPodilTest2()
        {
            Tuple<int, Program.JakToDopadlo> vysledek
                = Program.Podil("24 2");
            Assert.AreEqual(vysledek.Item1, 15);
            Assert.AreEqual(vysledek.Item2,
                Program.JakToDopadlo.OK);
        }

        [TestMethod()]
        [ExpectedException(typeof(DivideByZeroException))]
        public void OtestujPodilTest3()
        {
            Tuple<int, Program.JakToDopadlo> vysledek
                = Program.Podil("24 0");
            Assert.AreEqual(vysledek.Item1, 15);
            Assert.AreEqual(vysledek.Item2,
                Program.JakToDopadlo.DeleniNulou);
        }
    }
}